﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace Post8735
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-131.22, 55.05, -54.03, 16.91);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                Map1.CustomOverlays.Add(worldMapKitOverlay);

                ShapeFileFeatureLayer statesLayer = new ShapeFileFeatureLayer(Server.MapPath("~/App_Data/states.shp"));
                statesLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Green));
                statesLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                statesLayer.Open();
                Map1.HighlightOverlay.HighlightStyle = new FeatureOverlayStyle(GeoColor.FromArgb(120, GeoColor.StandardColors.OrangeRed), GeoColor.StandardColors.Red, 1);
                Map1.HighlightOverlay.Click += new EventHandler<HighlightFeatureOverlayClickEventArgs>(HighlightOverlay_Click);
                foreach (Feature feature in statesLayer.FeatureSource.GetAllFeatures(ReturningColumnsType.NoColumns))
                {
                    Map1.HighlightOverlay.Features.Add(feature.Id, feature);
                }
                statesLayer.Close();
            }
        }

        void HighlightOverlay_Click(object sender, HighlightFeatureOverlayClickEventArgs e)
        {
            foreach (Popup p in Map1.Popups)
            {
                p.IsVisible = false;
            }

            if (!Map1.Popups.Contains(e.ClickedFeature.Id))
            {
                CloudPopup popup = new CloudPopup(e.ClickedFeature.Id, e.Location, "<div style='font-size:11px'>Your popup</Div>");
                popup.HasCloseButton = true;
                popup.AutoSize = true;
                Map1.Popups.Add(popup);
            }
            else
            {
                Map1.Popups[e.ClickedFeature.Id].IsVisible = true;
            }
        }
    }
}
